6----Prime Path(bfs)

Prime Path

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0

#include<cstdio>
#include<iostream>
#include<queue>
#include<cstring>
#include<cmath>
using namespace std;
int m,n;
int flag[10000];
int sor(int x)
{
    for(int i=2;i<=sqrt((float)x);i++)
    {
        if(x%i==0)
            return 0;//不是素数
    }
    return 1;//是素数
}
void bfs()
{
    int t;
    queue<int>st;
    st.push(m);
    flag[m]=1;//等会判断条件要减去1
    while(!st.empty())
    {
        t=st.front();
        st.pop();
        if(t==n)
        {
            cout<<flag[n]-1<<endl;
            return;
        }
        for(int i=0;i<=9;i++)
        {
            int v=t/10*10+i;
            if(sor(v)&&!flag[v])
            {
                flag[v]=flag[t]+1;
                st.push(v);
            }
        }
        for(int i=0;i<=9;i++)
        {
            int v=t/100*100+i*10+t%10;
            if(sor(v)&&!flag[v])
            {
                flag[v]=flag[t]+1;
                st.push(v);
            }
        }
        for(int i=0;i<=9;i++)
        {
            int v=t/1000*1000+i*100+t%100;
            if(sor(v)&&!flag[v])
            {
                flag[v]=flag[t]+1;
                st.push(v);
            }
        }
        for(int i=1;i<=9;i++)
        {
            int v=i*1000+t%1000;
            if(sor(v)&&!flag[v])
            {
                flag[v]=flag[t]+1;
                st.push(v);
            }
        }
    }
}
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        memset(flag,0,sizeof(flag));
        cin>>m>>n;
        bfs();
    }
    return 0;
}

此题与前面几个差不多,都是利用了宽搜
宽搜的基本步骤如下:
1.queuename//建立队列
2。存入元素 并进行标记
3.while(!name.empty())
4,在循环里面进行入队,出队操作

此题用到了判断素数的函数,关于素数的函数有好几种判定,等下会特意写个专题
喜欢就关注一下

猜你喜欢

转载自blog.csdn.net/Nacht_one/article/details/81774640